/******************************************************************************
FTP-CAM v0.14 2024.11.09
Based on FTPClient_UploadImage.ino by Khoi Hoang
https://github.com/khoih-prog/FTPClient_Generic
******************************************************************************/

#include "Arduino.h"
#include "defines.h"
#include <FTPClient_Generic.h>
#include "octocat.h"

#include <SPI.h>
#include <SD.h>
File myFile1;
#define chipSelect 4
char fileName[8];
byte fileNumber;

// To use `true` with the following PASV mode asnswer from server, such as `VSFTP`
// 227 Entering Passive Mode (192,168,2,112,157,218)
// Using `false` with old style PASV answer, such as `FTP_Server_Teensy41` library
// 227 Entering Passive Mode (4043483328, port 55600)
#define USING_VSFTP_SERVER      false   //true

#if USING_VSFTP_SERVER
        // Change according to your FTP server
        char ftp_server[] = "ftp.homepage.shinobi.jp";
        char ftp_user[]   = "k183.bake-neko.net";
        char ftp_pass[]   = "*********";
        char dirName[]    = "/";
        char newDirName[] = "/test";
#else
        // Change according to your FTP server
        char ftp_server[] = "ftp.homepage.shinobi.jp";
        char ftp_user[]   = "k183.bake-neko.net";
        char ftp_pass[]   = "*********";
        char dirName[]    = "/";
        char newDirName[] = "/test";
#endif

// FTPClient_Generic(char* _serverAdress, char* _userName, char* _passWord, uint16_t _timeout = 10000);
FTPClient_Generic ftp (ftp_server, ftp_user, ftp_pass, 60000);

void initEthernet()
{
        #if USE_ETHERNET_PORTENTA_H7
                ET_LOGWARN(F("======== USE_PORTENTA_H7_ETHERNET ========"));
        #elif USE_NATIVE_ETHERNET
                ET_LOGWARN(F("======== USE_NATIVE_ETHERNET ========"));
        #elif USE_ETHERNET_GENERIC
                ET_LOGWARN(F("=========== USE_ETHERNET_GENERIC ==========="));
        #elif USE_ETHERNET_ESP8266
                ET_LOGWARN(F("=========== USE_ETHERNET_ESP8266 ==========="));
        #elif USE_ETHERNET_ENC
                ET_LOGWARN(F("=========== USE_ETHERNET_ENC ==========="));
        #else
                ET_LOGWARN(F("========================="));
        #endif
        #if !(USE_NATIVE_ETHERNET || USE_ETHERNET_PORTENTA_H7)
                #if (USING_SPI2)
                        #if defined(CUR_PIN_MISO)
                                ET_LOGWARN(F("Default SPI pinout:"));
                                ET_LOGWARN1(F("MOSI:"), CUR_PIN_MOSI);
                                ET_LOGWARN1(F("MISO:"), CUR_PIN_MISO);
                                ET_LOGWARN1(F("SCK:"),  CUR_PIN_SCK);
                                ET_LOGWARN1(F("SS:"),   CUR_PIN_SS);
                                ET_LOGWARN(F("========================="));
                        #endif
                #else
                        ET_LOGWARN(F("Default SPI pinout:"));
                        ET_LOGWARN1(F("MOSI:"), MOSI);
                        ET_LOGWARN1(F("MISO:"), MISO);
                        ET_LOGWARN1(F("SCK:"),  SCK);
                        ET_LOGWARN1(F("SS:"),   SS);
                        ET_LOGWARN(F("========================="));
                #endif
                #if defined(ESP8266)
                        // For ESP8266, change for other boards if necessary
                        #ifndef USE_THIS_SS_PIN
                                #define USE_THIS_SS_PIN   D2    // For ESP8266
                        #endif
                        ET_LOGWARN1(F("ESP8266 setCsPin:"), USE_THIS_SS_PIN);
                        #if ( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC )
                                // For ESP8266
                                // Pin                D0(GPIO16)    D1(GPIO5)    D2(GPIO4)    D3(GPIO0)    D4(GPIO2)    D8
                                // EthernetGeneric    X                 X            X            X            X        0
                                // Ethernet_ESP8266   0                 0            0            0            0        0
                                // D2 is safe to used for Ethernet, Ethernet2, Ethernet3, EthernetLarge libs
                                // Must use library patch for Ethernet, EthernetLarge libraries
                                Ethernet.init (USE_THIS_SS_PIN);        
                        #elif USE_CUSTOM_ETHERNET
                                // You have to add initialization for your Custom Ethernet here
                                // This is just an example to setCSPin to USE_THIS_SS_PIN, and can be not correct and enough
                                Ethernet.init(USE_THIS_SS_PIN);        
                        #endif  //( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC )
                        
                #elif defined(ESP32)
                        // You can use Ethernet.init(pin) to configure the CS pin
                        //Ethernet.init(10);  // Most Arduino shields
                        //Ethernet.init(5);   // MKR ETH shield
                        //Ethernet.init(0);   // Teensy 2.0
                        //Ethernet.init(20);  // Teensy++ 2.0
                        //Ethernet.init(15);  // ESP8266 with Adafruit Featherwing Ethernet
                        //Ethernet.init(33);  // ESP32 with Adafruit Featherwing Ethernet
                        #ifndef USE_THIS_SS_PIN
                                #define USE_THIS_SS_PIN   5   //22    // For ESP32
                        #endif
                        ET_LOGWARN1(F("ESP32 setCsPin:"), USE_THIS_SS_PIN);
                        // For other boards, to change if necessary
                        #if ( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC )
                                // Must use library patch for Ethernet, EthernetLarge libraries
                                // ESP32 => GPIO2,4,5,13,15,21,22 OK with Ethernet, Ethernet2, EthernetLarge
                                // ESP32 => GPIO2,4,5,15,21,22 OK with Ethernet3
                                //Ethernet.setCsPin (USE_THIS_SS_PIN);
                                Ethernet.init (USE_THIS_SS_PIN);        
                        #elif USE_CUSTOM_ETHERNET
                                // You have to add initialization for your Custom Ethernet here
                                // This is just an example to setCSPin to USE_THIS_SS_PIN, and can be not correct and enough
                                Ethernet.init(USE_THIS_SS_PIN);        
                        #endif  //( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC )

                #elif ETHERNET_USE_RPIPICO
                        pinMode(USE_THIS_SS_PIN, OUTPUT);
                        digitalWrite(USE_THIS_SS_PIN, HIGH);
                        // ETHERNET_USE_RPIPICO, use default SS = 5 or 17
                        #ifndef USE_THIS_SS_PIN
                                #if defined(ARDUINO_ARCH_MBED)
                                        #define USE_THIS_SS_PIN   5     // For Arduino Mbed core
                                #else
                                        #define USE_THIS_SS_PIN   17    // For E.Philhower core
                                #endif
                        #endif
                        ET_LOGWARN1(F("RPIPICO setCsPin:"), USE_THIS_SS_PIN);
                        // For other boards, to change if necessary
                        #if ( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC )
                                // Must use library patch for Ethernet, EthernetLarge libraries
                                // For RPI Pico using Arduino Mbed RP2040 core
                                // SCK: GPIO2,  MOSI: GPIO3, MISO: GPIO4, SS/CS: GPIO5
                                // For RPI Pico using E. Philhower RP2040 core
                                // SCK: GPIO18,  MOSI: GPIO19, MISO: GPIO16, SS/CS: GPIO17
                                // Default pin 5/17 to SS/CS
                                //Ethernet.setCsPin (USE_THIS_SS_PIN);
                                Ethernet.init (USE_THIS_SS_PIN);
                        #endif //( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC )

                #else //defined(ESP8266)
                        // unknown board, do nothing, use default SS = 10
                        #ifndef USE_THIS_SS_PIN
                                #define USE_THIS_SS_PIN   10    // For other boards
                        #endif
                        #if defined(BOARD_NAME)
                                ET_LOGWARN3(F("Board :"), BOARD_NAME, F(", setCsPin:"), USE_THIS_SS_PIN);
                        #else
                                ET_LOGWARN1(F("Unknown board setCsPin:"), USE_THIS_SS_PIN);
                        #endif
                        // For other boards, to change if necessary
                        #if ( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC || USE_NATIVE_ETHERNET )
                                // Must use library patch for Ethernet, Ethernet2, EthernetLarge libraries
                                Ethernet.init (USE_THIS_SS_PIN);
                        #elif USE_CUSTOM_ETHERNET
                                // You have to add initialization for your Custom Ethernet here
                                // This is just an example to setCSPin to USE_THIS_SS_PIN, and can be not correct and enough
                                Ethernet.init(USE_THIS_SS_PIN);
                        #endif  //( USE_ETHERNET_GENERIC || USE_ETHERNET_ENC )
                #endif  // defined(ESP8266)
        #endif  // #if !(USE_NATIVE_ETHERNET)
        
        // start the ethernet connection and the server:
        // Use DHCP dynamic IP and random mac
        uint16_t index = millis() % NUMBER_OF_MAC;
        // Use Static IP
        //Ethernet.begin(mac[0], ip);
        Ethernet.begin(mac[index]);
        
        #if !(USE_NATIVE_ETHERNET || USE_ETHERNET_PORTENTA_H7)
                ET_LOGWARN(F("========================="));
                #if defined( ESP32 )
                        // Just info to know how to connect correctly
                        // To change for other SPI
                        ET_LOGWARN(F("Currently Used SPI pinout:"));
                        ET_LOGWARN1(F("MOSI:"), PIN_MOSI);
                        ET_LOGWARN1(F("MISO:"), PIN_MISO);
                        ET_LOGWARN1(F("SCK:"),  PIN_SCK);
                        ET_LOGWARN1(F("SS:"),   PIN_SS);
                #else
                        #if defined(CUR_PIN_MISO)
                                ET_LOGWARN(F("Currently Used SPI pinout:"));
                                ET_LOGWARN1(F("MOSI:"), CUR_PIN_MOSI);
                                ET_LOGWARN1(F("MISO:"), CUR_PIN_MISO);
                                ET_LOGWARN1(F("SCK:"),  CUR_PIN_SCK);
                                ET_LOGWARN1(F("SS:"),   CUR_PIN_SS);
                        #else
                                ET_LOGWARN(F("Currently Used SPI pinout:"));
                                ET_LOGWARN1(F("MOSI:"), MOSI);
                                ET_LOGWARN1(F("MISO:"), MISO);
                                ET_LOGWARN1(F("SCK:"),  SCK);
                                ET_LOGWARN1(F("SS:"),   SS);
                        #endif
                #endif
                ET_LOGWARN(F("========================="));
                
        #elif (USE_ETHERNET_PORTENTA_H7)
                if (Ethernet.hardwareStatus() == EthernetNoHardware)
                {
                        Serial.println("No Ethernet found. Stay here forever");
                        while (true)
                        {
                                delay(1); // do nothing, no point running without Ethernet hardware
                        }
                }
                if (Ethernet.linkStatus() == LinkOFF)
                {
                        Serial.println("Not connected Ethernet cable");
                }
        #endif
        
        Serial.print(F("Using mac index = "));
        Serial.println(index);
        Serial.print(F("Connected! IP address: "));
        Serial.println(Ethernet.localIP());
}

void setup()
{
        char ch;
        
        Serial.begin(115200); //for Debug
        Serial1.begin(38400); //Camera Serial
        while (!Serial && millis() < 5000);
        delay(500);
        
        while(Serial.available())
        {
                ch = Serial.read(); //flush
        }
        while(Serial1.available())
        {
                ch = Serial1.read(); //flush
        }
        Serial.println("SERIAL READY");
        
        pinMode(10, OUTPUT);
        pinMode(31, OUTPUT); //LED(ERROR)
        pinMode(33, OUTPUT); //LED(SHOT,SEND)
        digitalWrite(31, LOW);
        digitalWrite(33, LOW);
        
        if (!SD.begin(chipSelect))
        {
                Serial.println("ERROR: INSERT SD CARD AND RESTART");
                digitalWrite(31, HIGH);
                return ;
        }
        Serial.println("SD CARD INITIALIZED");
        //Serial.println();
        
        pinMode(47, INPUT);
        pinMode(49, INPUT);
        digitalWrite(47, 1); //INTERNAL PULL UP
        digitalWrite(49, 1); //INTERNAL PULL UP
      
        Serial.print(F("\nStarting FTPClient_UploadImage on "));
        Serial.print(BOARD_NAME);
        Serial.print(F(" with "));
        Serial.println(SHIELD_TYPE);
        Serial.println(FTPCLIENT_GENERIC_VERSION);
      
        initEthernet();
        Serial.println();
}

void jpegTake(void)
{
        //--cam reset
        Serial1.print((char)0x56);
        Serial1.print((char)0x00);
        Serial1.print((char)0x26);
        Serial1.print((char)0x00);
        delay(2500);
        
        while(!Serial1.available()){ }
        while(Serial1.available())
        {
                Serial.print(Serial1.read(), HEX);
                Serial.print(" ");
        }
        Serial.println();
        
        //--cam setSize
        Serial1.print((char)0x56);
        Serial1.print((char)0x00);
        Serial1.print((char)0x54);
        Serial1.print((char)0x01);
        Serial1.print((char)0x11); //320*240:
        delay(100);
        
        while(!Serial1.available()){ }
        while(Serial1.available())
        {
                Serial.print(Serial1.read(), HEX);
                Serial.print(" ");
        }
        Serial.println();
        
        //--cam compRatio
        Serial1.print((char)0x56);
        Serial1.print((char)0x00);
        Serial1.print((char)0x31);
        Serial1.print((char)0x05);
        Serial1.print((char)0x01);
        Serial1.print((char)0x01);
        Serial1.print((char)0x12);
        Serial1.print((char)0x04);
        Serial1.print((char)0x36); //SMALLER VALUE: LESS COMPRESSED (DEFAULT: 0x36)
        delay(100);
        
        while(!Serial1.available()){ }
        while(Serial1.available())
        {
                Serial.print(Serial1.read(), HEX);
                Serial.print(" ");
        }
        Serial.println();
        
        //--cam motionDetectEnable
        //Serial1.print((char)0x56);
        //Serial1.print((char)0x00);
        //Serial1.print((char)0x42);
        //Serial1.print((char)0x03);
        //Serial1.print((char)0x00);
        //Serial1.print((char)0x01);
        //Serial1.print((char)0x01);
        //delay(100);
        
        //while(!Serial1.available()){ }
        //while(Serial1.available())
        //{
        //        Serial.print(Serial1.read(), HEX);
        //        Serial.print(" ");
        //}
        //Serial.println();
        
        Serial.println("JPEG CAMERA INITIALIZED");
        Serial.println();
        
        delay(100);
        
        byte start_addr_m;
        byte start_addr_l;
        int  byteCount;
        byte incomingByte;
        byte last2bytes[2];
        boolean jpegEnd;
        boolean err;
        
        String string1 = String("S");
        String string2 = String("");
        String string3 = String(".JPG");
        String string4 = String("");
        
        Serial.println("NEW FILE");
        
        //--cam takePhoto
        digitalWrite(33, HIGH);
        Serial1.print((char)0x56);
        Serial1.print((char)0x00);
        Serial1.print((char)0x36);
        Serial1.print((char)0x01);
        Serial1.print((char)0x00);
        delay(100);
        
        while(!Serial1.available()){ }
        digitalWrite(33, LOW);
        while(Serial1.available())
        {
                Serial.print(Serial1.read(), HEX);
                Serial.print(" ");
        }
        Serial.println();
        
        //--cam readSize
        Serial1.print((char)0x56);
        Serial1.print((char)0x00);
        Serial1.print((char)0x34);
        Serial1.print((char)0x01);
        Serial1.print((char)0x00);
        delay(100);
        
        while(!Serial1.available()){ }
        while(Serial1.available())
        {
                Serial.print(Serial1.read(), HEX);
                Serial.print(" ");
        }
        Serial.println();
        
        //--cam readContent
        start_addr_m = 0x00;
        start_addr_l = 0x00;
        jpegEnd = false;
        
        //--jpeg fileSave
        string2 = String(fileNumber);
        string4 = String(string1 + string2 + string3);
        string4.toCharArray(fileName, 8);
        
        err = false;
        myFile1 = SD.open(fileName, FILE_WRITE | O_TRUNC);
        if(myFile1)
        {
                while(!jpegEnd)
                {
                        /*
                        Serial.print("start_addr: ");
                        Serial.print(start_addr_m, HEX);
                        Serial.print(" ");
                        Serial.print(start_addr_l, HEX);
                        Serial.println();
                        delay(10);
                        */
                        Serial1.print((char)0x56);
                        Serial1.print((char)0x00);
                        Serial1.print((char)0x32);
                        Serial1.print((char)0x0C);
                        Serial1.print((char)0x00);
                        Serial1.print((char)0x0A);
                        Serial1.print((char)0x00);
                        Serial1.print((char)0x00);
                        
                        Serial1.print((char)start_addr_m);  //MM
                        Serial1.print((char)start_addr_l);  //MM
                        
                        Serial1.print((char)0x00);
                        Serial1.print((char)0x00);
                        Serial1.print((char)0x00);  //KK
                        Serial1.print((char)0x20);  //KK (DEC:32)
                        Serial1.print((char)0x00);  //XX
                        Serial1.print((char)0x0A);  //XX
                        
                        while(!Serial1.available()){ }
                        delay(22); //10ms at least
                        
                        byteCount = 0;
                        while(Serial1.available())
                        {
                                incomingByte = Serial1.read();
                                /*
                                Serial.print(incomingByte, HEX);
                                Serial.print(" ");
                                */
                                
                                if(byteCount >=5 && byteCount <=36)
                                {
                                        myFile1.write(incomingByte);
                                        
                                        last2bytes[1] = incomingByte;
                                        if(last2bytes[0] == 0xFF && last2bytes[1] == 0xD9)
                                        {
                                                /*
                                                Serial.println("CAUGHT FFD9!");
                                                */
                                                jpegEnd = true;
                                        }
                                        last2bytes[0] = last2bytes[1];
                                }
                                byteCount++;
                        }
                        /*
                        Serial.println();
                        */
                        if(start_addr_l == 0xE0)
                        {
                                start_addr_l = 0x00;
                                start_addr_m += 0x01;
                        }
                        else
                        {
                                start_addr_l += 0x20; //DEC:32
                        }
                }
        }
        else
        {
                Serial.println("CAN'T OPEN FILE");
                err = true;
        }
        myFile1.close();
        
        if(err == true)
        {
                digitalWrite(31, HIGH);
                while(1);
        }
        else
        {
                Serial.print("fileName=");
                Serial.println(fileName);
                Serial.println("JPEG FILE SAVED");
                Serial.println();
        }
        
        //--cam stop
        Serial1.print((char)0x56);
        Serial1.print((char)0x00);
        Serial1.print((char)0x36);
        Serial1.print((char)0x01);
        Serial1.print((char)0x03);
        delay(100);
        
        while(!Serial1.available()){ }
        while(Serial1.available())
        {
                Serial.print(Serial1.read(), HEX);
                Serial.print(" ");
        }
        Serial.println();
}

void loop()
{
        int i,j,k;
        
        jpegTake();
        
        Serial.println();
        ftp.OpenConnection();
        ftp.ChangeWorkDir(dirName);
      
        //Get the file size
        String       list[128];
        
        #if !(ESP8266)
                boolean err;
                byte dummy;
                int fileSize = 0;
                
                err = false;
                myFile1 = SD.open("S0.JPG");
                if(myFile1)
                {
                        while(myFile1.available()) //-- measure jpeg file size --
                        {
                                 dummy = myFile1.read();
                                 fileSize++;
                        }
                        Serial.print("fileSize=");
                        Serial.println(fileSize);
                }
                else
                {
                        Serial.println("CAN'T OPEN FILE");
                        err = true;
                }
                myFile1.close();
        
                if(err == true)
                {
                        digitalWrite(31, HIGH);
                        while(1);
                }
                
                byte camera_pic[fileSize]; //-- create variable --
                err = false;
                myFile1 = SD.open("S0.JPG");
                if(myFile1)
                {
                        i = 0;
                        while(myFile1.available())  //-- convert from .jpeg to variable --
                        {
                                 camera_pic[i] = myFile1.read();
                                 i++;
                        }
                        //for(j = 0; j < fileSize; j++){
                        //        Serial.print(camera_pic[j], HEX);  //-- check content --
                        //        Serial.print(',');
                        //}
                        //Serial.println();
                }
                else
                {
                        Serial.println("CAN'T OPEN FILE");
                        err = true;
                }
                myFile1.close();
                
                if(err == true)
                {
                        digitalWrite(31, HIGH);
                        while(1);
                }
                
                Serial.print("Writing out.jpg, size = ");
                Serial.println(sizeof(camera_pic));
                
                ftp.InitFile(COMMAND_XFER_TYPE_BINARY);
                ftp.NewFile("out.jpg");
                ftp.WriteData( camera_pic, sizeof(camera_pic) );
                ftp.CloseFile();
        #endif
        
        ftp.CloseConnection();
        
        for(j = 0; j < 2; j++) //interval 2 min.
        {
                for(k = 0; k < 60; k++)
                {
                        Serial.print('.');
                        delay(1000);
                }
                Serial.println();
        }
}
